/*----------------------------------------------------*/
/*-----------------------FASTE------------------------*/
/*----------------------------------------------------*/
/*--Recipe selector based on almost expired products--*/
/*----------------------------------------------------*/
/*----------------------MADE BY-----------------------*/
/*----------------------------------------------------*/
/*-------------------- Geert Mol ---------------------*/
/*----------------- Matthijs Sluijk ------------------*/
/*---------------- Jordy van Hierden -----------------*/
/*------------------- Thomas Gort --------------------*/
/*----------------- Babet ten Hagen ------------------*/
/*------------------ Sarah Jansen --------------------*/
/*-------------------- Carmen Pol --------------------*/
/*----------------------------------------------------*/

import processing.serial.*;
Serial scanner;
Serial lights;

UI ui;

// Amount of shelves
int productAmount = 6;

// Array of correct UIDs
String[] correct = {"7EEB647E", "4EDE647E", "3EEC647E", "04304D5AEE648", "1EEB647E", "DEEB647E"};
// Array to store the current UIDs on the shelf
String[] shelf = new String[productAmount];
// Array to store the current LED value of the shelfs
int[] led = new int[productAmount];

// Array of recipes
ArrayList<Recipe> recipes;
// Array of products
ArrayList<Product> products;
// Array to keep track of which products are expired
ArrayList<String> expired;

// Integer to remember the recipe which has to most ingredients that are about to expire


/*----------------*/
/*---Initialize---*/
/*----------------*/
void setup() {
  fullScreen();
  imageMode(CENTER);

  scanner = new Serial(this, "COM4", 9600);
  lights = new Serial(this, "COM3", 9600);
  
  ui = new UI();
  
  products = new ArrayList<Product>();
  recipes = new ArrayList<Recipe>();

  addProducts();
  addRecipes();
}


/*----------------*/
/*---Main Loop----*/
/*----------------*/
void draw() {
  // Empty the expired ArrayList every frame
  expired = new ArrayList<String>();
  
  // Read the serial port
  scanProducts();
  
  // For every product check if it is on the shelf and if so check the UID
  for (int i = 0; i < productAmount; i++) {
    println(shelf[i]);
    if (shelf[i] != null) {
      correctProduct(i); // Turn the purple led on if a product is on the shelf
      checkUIDs(i);      // Check if it is the correct product
    }
    // If nothing is on the shelf turn of the led
    if (shelf[i] != null && shelf[i].length() == 0) {
      noProduct(i);
    }
  }

  // Make a variable called led info which contains which shelf it is (tens) and which state the led is (unit)
  // Shelf 0 to 5 and led state 0 to 3 with:
  // 0 = no product
  // 1 = product on shelf
  // 2 = almost expired product
  // 3 = wrong product on shelf
  // So 32 means the third shelf and the product is almost expired.
  for (int i = 0; i < led.length; i++) {
    int ten = i * 10;
    int unit = led[i];
    int ledinfo = ten + unit;
    lights.write(ledinfo);
  }
  

  // Display the user interface
  ui.display();
  
  println(led);
}

void mousePressed() {
  if (searchButton(mouseX, mouseY) && ui.screen == 8) {
    ui.screen = selectRecipe();
  }
  if (backButton(mouseX, mouseY)) {
    ui.screen = 8;
  }
}
