void addProducts() {
  products.add(new Product("Noodles", 2021 , 1, 20));
  products.add(new Product("Canned tomatoes", 2020, 1, 29));
  products.add(new Product("Tacos", 2021, 5, 17));
  products.add(new Product("Creme fraiche", 2020, 1, 29));
  products.add(new Product("Nachos", 2021, 1, 16));
  products.add(new Product("Lime", 2020, 1, 17));
}

void addRecipes() {
  recipes.add(new Recipe("Mexican tortillas", tortillasIng));
  recipes.add(new Recipe("Mexican soup with lime and yellow rice", soupIng));
  recipes.add(new Recipe("Mexican bean salad", beanSaladIng));
  recipes.add(new Recipe("Mexican Pizza", pizzaIng));
  recipes.add(new Recipe("Mexican oven dish", ovenIng));
  recipes.add(new Recipe("Mexican taco salad", tacoSaladIng));
  recipes.add(new Recipe("Mexican rice dish", riceIng));
  recipes.add(new Recipe("Mexican vegetarian lasagne", lasagneIng));
}

// Product states
void noProduct(int product) {
  led[product] = 0;
}
void correctProduct(int product) {
  led[product] = 1;
}
void expiredProduct(int product) {
  led[product] = 2;
}
void wrongProduct(int product) {
  led[product] = 3;
}

void checkUIDs(int product) {
  if (shelf[product].equals(correct[product])) {
    checkDate(product); // If it is the correct product check the date
  } else {
    wrongProduct(product);
  }
}

void checkDate(int product) {
  Product current = products.get(product);
  if (current.year == year() && current.month == month()) {
    if (current.day <= day() + 2) {
      expired.add(current.name);
      expiredProduct(product);
    }
  }
}

int selectRecipe() {
  int selectedRecipe = 0;
  int productsInRecipe = 0;
  
  for (int i = 0; i < recipes.size(); i++) {
    int current = 0;
    for (int j = 0; j < recipes.get(i).ingredients.length; j++) {
      for (int k = 0; k < expired.size(); k++) {
        
        if (expired.get(k) == recipes.get(i).ingredients[j]) {
          current++;
        }
      }
    }
    if (current > productsInRecipe) {
      productsInRecipe = current;
      selectedRecipe = i;
    }
    println(current);
  }
  println(recipes.get(selectedRecipe).name);
  
  return selectedRecipe;
}
