#include <FastLED.h>
#define LED_PIN     7
#define NUM_LEDS    60
CRGB leds[NUM_LEDS];

// Incoming data
int inc;

void setup() {
  Serial.begin(9600);
  FastLED.addLeds<WS2812, LED_PIN, GRB>(leds, NUM_LEDS);
}
void loop() {
  if (Serial.available() > 0) {
    // Read the incoming data
    inc = Serial.read();

    // Calculate which shelf (ten - 0 to 5)
    // Calculate the ledstate (unit - 0 to 3)
    int unit = inc % 10;
    int ten = inc - unit;

    change(ten, ten + 10, unit);
  }
  change(0, 30, 2);
  change(30, 60, 1);
  FastLED.show();
}

void change(int start, int finish, int mode) {
  for (int i = start; i < finish; i++) {
    if (mode == 0) {
      leds[i] = CRGB(0, 0, 0);
    } else if (mode == 1) {
      leds[i] = CRGB(201, 104, 212);
    } else if (mode == 2) {
      leds[i] = CRGB(3, 252, 15);
    } else if (mode == 3) {
      leds[i] = CRGB(255, 0, 0);
    }
  }
}
